/**
 * Copyright 2020 Huawei Technologies Co., Ltd
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef MINDSPORE_CCSRC_OPTIMIZER_IRPASS_PRIM_ELIMINATE_H_
#define MINDSPORE_CCSRC_OPTIMIZER_IRPASS_PRIM_ELIMINATE_H_

#include "optimizer/optimizer.h"
#include "optimizer/irpass.h"
#include "ir/visitor.h"

namespace mindspore {
namespace opt {
namespace irpass {
// {prim, X}
class PrimEliminater : public AnfVisitor {
 public:
  explicit PrimEliminater(const PrimitivePtr &prim) : prim_(prim) {}
  ~PrimEliminater() override = default;

  AnfNodePtr operator()(const OptimizerPtr &, const AnfNodePtr &node) override {
    x_ = nullptr;
    AnfVisitor::Match(prim_, {IsNode})(node);
    return x_;
  }

  void Visit(const AnfNodePtr &node) override { x_ = node; }

 private:
  AnfNodePtr x_{nullptr};
  PrimitivePtr prim_;
};
}  // namespace irpass
}  // namespace opt
}  // namespace mindspore

#endif  // MINDSPORE_CCSRC_OPTIMIZER_IRPASS_PRIM_ELIMINATE_H_
